﻿*** The following command weights the data by the number of marriages for a particular year and age at marriage range which either
*** ended in divorce or did not end in divorce.

WEIGHT BY marriages.

*** The following commands calculate the proportions of cases for a particular year and age at marriage range falling into each of the 
***  12 age at marriage ranges covered by the 'step' variables.

compute step1=0.
compute step2=0.
compute step3=0.
compute step4=0.
compute step5=0.
compute step6=0.
compute step7=0.
compute step8=0.
compute step9=0.
compute step10=0.
compute step11=0.
compute step12=0.
execute.
if (lowerprop lt 0.05 and upperprop lt 0.05)step1=upperprop-lowerprop.
if (lowerprop lt 0.05 and upperprop ge 0.05)step1=0.05-lowerprop.
if (lowerprop ge 0.05 and lowerprop lt 0.1 and upperprop lt 0.1)step2=upperprop-lowerprop.
if (lowerprop ge 0.05 and lowerprop lt 0.1 and upperprop ge 0.1)step2=0.1-lowerprop.
if (lowerprop lt 0.05 and upperprop lt 0.1 and upperprop ge 0.05)step2=upperprop-0.05.
if (lowerprop lt 0.05 and upperprop ge 0.1)step2=0.1-0.05.
if (lowerprop ge 0.1 and lowerprop lt 0.2 and upperprop lt 0.2)step3=upperprop-lowerprop.
if (lowerprop ge 0.1 and lowerprop lt 0.2 and upperprop ge 0.2)step3=0.2-lowerprop.
if (lowerprop lt 0.1 and upperprop lt 0.2 and upperprop ge 0.1)step3=upperprop-0.1.
if (lowerprop lt 0.1 and upperprop ge 0.2)step3=0.2-0.1.
if (lowerprop ge 0.2 and lowerprop lt 0.4 and upperprop lt 0.4)step4=upperprop-lowerprop.
if (lowerprop ge 0.2 and lowerprop lt 0.4 and upperprop ge 0.4)step4=0.4-lowerprop.
if (lowerprop lt 0.2 and upperprop lt 0.4 and upperprop ge 0.2)step4=upperprop-0.2.
if (lowerprop lt 0.2 and upperprop ge 0.4)step4=0.4-0.2.
if (lowerprop ge 0.4 and lowerprop lt 0.6 and upperprop lt 0.6)step5=upperprop-lowerprop.
if (lowerprop ge 0.4 and lowerprop lt 0.6 and upperprop ge 0.6)step5=0.6-lowerprop.
if (lowerprop lt 0.4 and upperprop lt 0.6 and upperprop ge 0.4)step5=upperprop-0.4.
if (lowerprop lt 0.4 and upperprop ge 0.6)step5=0.6-0.4.
if (lowerprop ge 0.6 and lowerprop lt 0.8 and upperprop lt 0.8)step6=upperprop-lowerprop.
if (lowerprop ge 0.6 and lowerprop lt 0.8 and upperprop ge 0.8)step6=0.8-lowerprop.
if (lowerprop lt 0.6 and upperprop lt 0.8 and upperprop ge 0.6)step6=upperprop-0.6.
if (lowerprop lt 0.6 and upperprop ge 0.8)step6=0.8-0.6.
if (lowerprop ge 0.8 and lowerprop lt 0.9 and upperprop lt 0.9)step7=upperprop-lowerprop.
if (lowerprop ge 0.8 and lowerprop lt 0.9 and upperprop ge 0.9)step7=0.9-lowerprop.
if (lowerprop lt 0.8 and upperprop lt 0.9 and upperprop ge 0.8)step7=upperprop-0.8.
if (lowerprop lt 0.8 and upperprop ge 0.9)step7=0.9-0.8.
if (lowerprop ge 0.9 and lowerprop lt 0.95 and upperprop lt 0.95)step8=upperprop-lowerprop.
if (lowerprop ge 0.9 and lowerprop lt 0.95 and upperprop ge 0.95)step8=0.95-lowerprop.
if (lowerprop lt 0.9 and upperprop lt 0.95 and upperprop ge 0.9)step8=upperprop-0.9.
if (lowerprop lt 0.9 and upperprop ge 0.95)step8=0.95-0.9.
if (lowerprop ge 0.95 and lowerprop lt 0.98 and upperprop lt 0.98)step9=upperprop-lowerprop.
if (lowerprop ge 0.95 and lowerprop lt 0.98 and upperprop ge 0.98)step9=0.98-lowerprop.
if (lowerprop lt 0.95 and upperprop lt 0.98 and upperprop ge 0.95)step9=upperprop-0.95.
if (lowerprop lt 0.95 and upperprop ge 0.98)step9=0.98-0.95.
if (lowerprop ge 0.98 and lowerprop lt 0.99 and upperprop lt 0.99)step10=upperprop-lowerprop.
if (lowerprop ge 0.98 and lowerprop lt 0.99 and upperprop ge 0.99)step10=0.99-lowerprop.
if (lowerprop lt 0.98 and upperprop lt 0.99 and upperprop ge 0.98)step10=upperprop-0.98.
if (lowerprop lt 0.98 and upperprop ge 0.99)step10=0.99-0.98.
if (lowerprop ge 0.99 and lowerprop lt 0.995 and upperprop lt 0.995)step11=upperprop-lowerprop.
if (lowerprop ge 0.99 and lowerprop lt 0.995 and upperprop ge 0.995)step11=0.995-lowerprop.
if (lowerprop lt 0.99 and upperprop lt 0.995 and upperprop ge 0.99)step11=upperprop-0.99.
if (lowerprop lt 0.99 and upperprop ge 0.995)step11=0.995-0.99.
if (lowerprop ge 0.995)step12=upperprop-lowerprop.
if (lowerprop lt 0.995 and upperprop ge 0.995)step12=upperprop-0.995.
execute.
 
compute step1p=step1/(upperprop-lowerprop).
compute step2p=step2/(upperprop-lowerprop).
compute step3p=step3/(upperprop-lowerprop).
compute step4p=step4/(upperprop-lowerprop).
compute step5p=step5/(upperprop-lowerprop).
compute step6p=step6/(upperprop-lowerprop).
compute step7p=step7/(upperprop-lowerprop).
compute step8p=step8/(upperprop-lowerprop).
compute step9p=step9/(upperprop-lowerprop).
compute step10p=step10/(upperprop-lowerprop).
compute step11p=step11/(upperprop-lowerprop).
compute step12p=step12/(upperprop-lowerprop).
execute.

*** The following commands calculate the average values for a particular year and age at marriage range for
*** the additional components which taken together with the median ranking measure define the linear spline 

compute slope05=0.
if (lowerprop lt 0.05)slope05=20*0.5*(-1)*(0.05-lowerprop)*(0.05-lowerprop)/(upperprop-lowerprop).
execute.
compute slope95=0.
if (upperprop gt 0.95 and lowerprop le 0.95)slope95=20*0.5*(upperprop-0.95)*(upperprop-0.95)/(upperprop-lowerprop).
if (upperprop gt 0.95 and lowerprop gt 0.95)slope95=20*0.5*((upperprop-0.95)+(lowerprop-0.95)).
EXECUTE .
compute slope99=0.
if (upperprop gt 0.99 and lowerprop le 0.99)slope99=100*0.5*(upperprop-0.99)*(upperprop-0.99)/(upperprop-lowerprop).
if (upperprop gt 0.99 and lowerprop gt 0.99)slope99=100*0.5*((upperprop-0.99)+(lowerprop-0.99)).
EXECUTE .
compute slope875=0.
if (upperprop gt 0.875 and lowerprop le 0.875)slope875=8*0.5*(upperprop-0.875)*(upperprop-0.875)/(upperprop-lowerprop).
if (upperprop gt 0.875 and lowerprop gt 0.875)slope875=8*0.5*((upperprop-0.875)+(lowerprop-0.875)).
execute.

*** The following command calculates the number of years since 1986 for years from 1987 onwards, giving a variable 
*** which together with one of the above components allows for post-1986 variation in the linear spline.

compute yearssince1986=yearscale-12.
if (yearssince1986 lt 0)yearssince1986=0.
execute.

*** The following command fits Models 1, 2 and 3.

LOGISTIC REGRESSION VARIABLES divorce
  /METHOD=ENTER year 
  /METHOD=ENTER aamrange 
  /METHOD=ENTER aamrange*year 
  /CONTRAST (year)=Indicator(1)
  /CONTRAST (aamrange)=Indicator(1)
  /CRITERIA=PIN(.05) POUT(.10) ITERATE(20) CUT(.5).

*** The following command fits Models 1, 2 and 4.

LOGISTIC REGRESSION VARIABLES divorce
  /METHOD=ENTER year 
  /METHOD=ENTER aamrange 
  /METHOD=ENTER aamrange*yearscale 
  /CONTRAST (year)=Indicator(1)
  /CONTRAST (aamrange)=Indicator(1)
  /CRITERIA=PIN(.05) POUT(.10) ITERATE(20) CUT(.5).

*** The following command fits Models 1, 2, 5 and 6.

LOGISTIC REGRESSION VARIABLES divorce
  /METHOD=ENTER year 
  /METHOD=ENTER aamrange 
  /METHOD=ENTER step2p step3p step4p step5p step6p step7p step8p step9p step10p step11p step12p 
  /METHOD=ENTER aamrange*yearscale 
  /CONTRAST (year)=Indicator(1)
  /CONTRAST (aamrange)=Indicator(1)
  /CRITERIA=PIN(.05) POUT(.10) ITERATE(20) CUT(.5).

*** The following command fits Models 1, 2 and 7.

LOGISTIC REGRESSION VARIABLES divorce
  /METHOD=ENTER year 
  /METHOD=ENTER aamrange 
  /METHOD=ENTER medrank 
  /CONTRAST (year)=Indicator(1)
  /CONTRAST (aamrange)=Indicator(1)
  /CRITERIA=PIN(.05) POUT(.10) ITERATE(20) CUT(.5).

*** The following command fits Models 1, 2, 8 and 9.

LOGISTIC REGRESSION VARIABLES divorce
  /METHOD=ENTER year 
  /METHOD=ENTER aamrange 
  /METHOD=ENTER medrank slope05 slope875 slope99 
  /METHOD=ENTER aamrange*yearscale 
  /CONTRAST (year)=Indicator(1)
  /CONTRAST (aamrange)=Indicator(1)
  /CRITERIA=PIN(.05) POUT(.10) ITERATE(20) CUT(.5).

*** The following command fits Models 1, 2, 8 and 10.

LOGISTIC REGRESSION VARIABLES divorce
  /METHOD=ENTER year 
  /METHOD=ENTER aamrange 
  /METHOD=ENTER medrank slope05 slope875 slope99 
  /METHOD=ENTER slope95*yearssince1986 
  /CONTRAST (year)=Indicator(1)
  /CONTRAST (aamrange)=Indicator(1)
  /CRITERIA=PIN(.05) POUT(.10) ITERATE(20) CUT(.5).

*** The following command fits Models 1a and 2a

LOGISTIC REGRESSION VARIABLES divorce
  /METHOD=ENTER yearscale 
  /METHOD=ENTER aamrange 
  /CONTRAST (aamrange)=Indicator(1)
  /CRITERIA=PIN(.05) POUT(.10) ITERATE(20) CUT(.5).





